#! /usr/bin/python
#coding=utf-8

import os,sys
import subprocess

def get_trap_info(nagios_path):
    dict_tmp = {}
    for sysline in sys.stdin:
        dict_tmp = dict(dict_tmp.items() + handle_trap_line(sysline).items())
    run_cmd = ""
    if dict_tmp["Severity_Value"].strip() == "0":
        #run_cmd = """%s/libexec/eventhandlers/submit_check_result %s "Critical Alert" 2 'Critical - MTM:%s; SN:%s; %s;' """ % (nagios_path, dict_tmp["IP"], dict_tmp["Machine_Type"], dict_tmp["Serial_Number"], dict_tmp["Alert_MSG_Text"])
        cmd_list = ["%s/libexec/eventhandlers/submit_check_result" % nagios_path, dict_tmp["IP"], "Critical Alert", "2",  "Critical - MTM:%s; SN:%s; %s;" % (dict_tmp["Machine_Type"], dict_tmp["Serial_Number"], dict_tmp["Alert_MSG_Text"]) ]
    elif dict_tmp["Severity_Value"].strip() == "4":
        cmd_list = ["%s/libexec/eventhandlers/submit_check_result" % nagios_path, dict_tmp["IP"], "System Alert", "0",  "INFO - MTM:%s; SN:%s; %s;" % (dict_tmp["Machine_Type"], dict_tmp["Serial_Number"], dict_tmp["Alert_MSG_Text"]) ]
    elif dict_tmp["Severity_Value"].strip() == "8":
        cmd_list = ["%s/libexec/eventhandlers/submit_check_result" % nagios_path, dict_tmp["IP"], "Critical Alert", "0",  "Recovery - MTM:%s; SN:%s; %s;" % (dict_tmp["Machine_Type"], dict_tmp["Serial_Number"], dict_tmp["Alert_MSG_Text"]) ]
    else:
        exit(0)
    run_watch = subprocess.Popen(
        cmd_list, stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True)
    ret, err_msg = run_watch.communicate()
    print ret + err_msg

def handle_trap_line(trap_line):
    """"Handle every line of snmptrap.

    Args: A line of trap

        like: ".1.3.6.1.4.1.19046.11.1.158.5.1.11 "System - Remote Login"

    Returns: 
        If the info is useful, return a dict which include the info
        Else return {}

        like: {"Alert_MSG_ID": "System - Remote Login"}
    """
    switch = {
        "8": "Severity_Value",
        "6": "Serial_Number",
        "9": "Alert_MSG_Text",
        "11": "Alert_MSG_ID",
        "22": "Machine_Type"
    }

    line = trap_line.strip()
    if line:
        # Get the IP address of SNMPTrap
        # UDP: [198.128.0.3]:51000->[198.128.0.4]:162
        if "UDP:" in line:
            l_index = line.find("[")
            r_index = line.find("]")
            ip_address= line[l_index+1:r_index]
            return {"IP": ip_address}
        # in debug module: .1.3.6.1.4.1.19046.11.1.158.5.1.6 "20170926"
        # in service module: 19046.11.1.158.5.1.6 "20170926"
        if "19046.11.1.158.5.1" in line:
            trap_OID = line.split(" ")[0]
            trap_value = line[line.find(" "):]
            trap_index = trap_OID.split(".")[-1]
            if str(trap_index) in switch:
                return {switch[str(trap_index)]: trap_value}
    return {}

if __name__ =='__main__':
    if len(sys.argv) <2:
        print "The param is not correct"
        exit()

    nagios_path = sys.argv[1]
    get_trap_info(nagios_path)

